StudentWritingCParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
StudentWritingCParser Class Referencefinal

the main class to read a Student Writing Center file More...

`#include <StudentWritingCParser.hxx>`

Inheritance diagram for StudentWritingCParser:

## Public Member Functions
| StudentWritingCParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~StudentWritingCParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readTextZone (StudentWritingCParserInternal::Zone const &zone)
| try to read a text zone with type=1 More...
bool | readFrame (StudentWritingCParserInternal::Zone &zone)
| try to read a frame zone with type=3 More...
bool | readParagraph (StudentWritingCParserInternal::Zone &zone)
| try to read the paragraph zone with type=4 More...
bool | readPicture (StudentWritingCParserInternal::Zone &zone)
| try to read a picture zone with type=6 More...
bool | readFontsList (MWAWEntry const &entry)
| try to read the font list: the first entry of a zone with type=7 More...
bool | readPrintInfo ()
| try to read the printer information More...
bool | sendZone (int id)
| try to send a zone knowing its id More...
bool | sendText (StudentWritingCParserInternal::Zone const &zone, StudentWritingCParserInternal::Zone const &parent, bool isMain=false)
| try to send the text(s) corresponding to a zone of type 5 More...
bool | sendPicture (MWAWPosition const &pos, int id)
| try to send a picture: type 6 More...
MWAWInputStreamPtr | decode ()
| low level: try to uncompress the different compressed zone More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< StudentWritingCParserInternal::State > | m_state
| the state More...

## Friends
class | StudentWritingCParserInternal::SubDocument

## Detailed Description

the main class to read a Student Writing Center file

## Constructor & Destructor Documentation

## ◆ StudentWritingCParser()

StudentWritingCParser::StudentWritingCParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~StudentWritingCParser()

StudentWritingCParser::~StudentWritingCParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool StudentWritingCParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void StudentWritingCParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool StudentWritingCParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ decode()

MWAWInputStreamPtr StudentWritingCParser::decode | ( |  | ) |
| protected

low level: try to uncompress the different compressed zone

Referenced by parse().

## ◆ parse()

void StudentWritingCParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readFontsList()

bool StudentWritingCParser::readFontsList | ( | MWAWEntry const & | entry | ) |
| protected

try to read the font list: the first entry of a zone with type=7

Referenced by createZones().

## ◆ readFrame()

bool StudentWritingCParser::readFrame | ( | StudentWritingCParserInternal::Zone & | zone | ) |
| protected

try to read a frame zone with type=3

Referenced by createZones().

## ◆ readParagraph()

bool StudentWritingCParser::readParagraph | ( | StudentWritingCParserInternal::Zone & | zone | ) |
| protected

try to read the paragraph zone with type=4

Referenced by createZones().

## ◆ readPicture()

bool StudentWritingCParser::readPicture | ( | StudentWritingCParserInternal::Zone & | zone | ) |
| protected

try to read a picture zone with type=6

Referenced by createZones().

## ◆ readPrintInfo()

bool StudentWritingCParser::readPrintInfo | ( |  | ) |
| protected

try to read the printer information

Referenced by createZones().

## ◆ readTextZone()

bool StudentWritingCParser::readTextZone | ( | StudentWritingCParserInternal::Zone const & | zone | ) |
| protected

try to read a text zone with type=1

Referenced by createZones().

## ◆ sendPicture()

bool StudentWritingCParser::sendPicture | ( | MWAWPosition const & | pos,
|  | int | id
| ) |  |
| protected

try to send a picture: type 6

Referenced by sendZone().

## ◆ sendText()

bool StudentWritingCParser::sendText | ( | StudentWritingCParserInternal::Zone const & | zone,
|  | StudentWritingCParserInternal::Zone const & | parent,
|  | bool | isMain = `false`
| ) |  |
| protected

try to send the text(s) corresponding to a zone of type 5

Referenced by sendZone().

## ◆ sendZone()

bool StudentWritingCParser::sendZone | ( | int | id | ) |
| protected

try to send a zone knowing its id

Referenced by parse().

## Friends And Related Function Documentation

## ◆ StudentWritingCParserInternal::SubDocument

friend class StudentWritingCParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<StudentWritingCParserInternal::State> StudentWritingCParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), decode(), parse(), readFontsList(), readFrame(), readTextZone(), sendPicture(), sendText(), sendZone(), and StudentWritingCParser().

The documentation for this class was generated from the following files:

- StudentWritingCParser.hxx
- StudentWritingCParser.cxx